﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Telerik.Windows.Controls.TimeBar;

namespace MVVM_Project
{
    public class WeekFormatterProvider : IIntervalFormatterProvider
    {
        private static Func<DateTime, string>[] formatters;
        private Func<DateTime, string>[] intervalSpanFormatters;

        public WeekFormatterProvider()
        {
            formatters = new Func<DateTime, string>[]
         {
               date => String.Format("Week {0}", GetWeekNumber(date).ToString()),
         };

        }

        public Func<DateTime, string>[] GetFormatters(IntervalBase interval)
        {
            return formatters;
        }

        public Func<DateTime, string>[] GetIntervalSpanFormatters(IntervalBase interval)
        {
            if (this.intervalSpanFormatters == null)
            {
                this.intervalSpanFormatters = new Func<DateTime, string>[]
                {
      date => String.Format("Week - {0}", GetWeekNumber(date).ToString())

                };
            }

            return this.intervalSpanFormatters;
        }

        public int GetWeekNumber(DateTime date)
        {
            CultureInfo ciCurr = CultureInfo.CurrentCulture;
            int weekNum = ciCurr.Calendar.GetWeekOfYear(date, CalendarWeekRule.FirstFourDayWeek, DayOfWeek.Monday);
            return weekNum;
        }
    }
}
